# Anykey

![Screenshot](screenshot.png)

This program monitors the keyboard and joysticks. It is useful to test hardware or to explore the key bindings of emulators.

It supports the following computers:

- Commodore 64
- Commodore 128 (128 mode in 40 columns or 64 mode)
- Commodore PET (all models with at least 8k RAM)
- Commodore Plus/4
- Commodore VIC-20 (at least 8k RAM expansion)
- MEGA65 (native and 64 mode)
- Sinclair ZX Spectrum 48k
- Sinclair ZX Spectrum 48k+
- Sinclair ZX Spectrum 128k
- Sinclair ZX Spectrum +2 (gray model, made by Sinclair)
- Sinclair ZX Spectrum +2A (black model, made by Amstrad)
- Sinclair ZX Spectrum +3
- Sinclair ZX Spectrum Next
- N-Go (ZX Spectrum Next clone)

The upper window shows the state of the keyboard.

If the computer has controller ports, the lower window shows the state of connected joysticks.

To test other controller types or joystick adapters, please use the companion program [Joyride](https://github.com/T-Pau/Joyride) (currently only available on C64).


## Using Anykey

For detailed usage instructions, see the documentation pages:

- [Commodore 8-Bit Computers](Documentation/Commodore.md)
- [Commodore PET](Documentation/Commodore%20PET.md)
- [Sinclair ZX Spectrum](Documentation/ZX%20Spectrum.md)


## Building Anykey

See [BUILDING.md](BUILDING.md)
